//// ==================================================================
//// Include C Libriaries
//// ==================================================================
//
//#include <avr/io.h>
//#define F_CPU 8000000UL
//#include <util/delay.h>
//#include <avr/interrupt.h>
//
//// ==================================================================
//// Portdefinitionen
//// ==================================================================
//
//#define IR_OUT_PORT PORTB
//#define IR_OUT_PIN PB1
//
//// ==================================================================
//// Timerdefinitionen
//// ==================================================================
//
//// Phasenkorrekter PWM / Vorteiler 1 / Compare-Wert = 55
//// Berechnung: 4 MHz / (2*50) = 40 kHz (40.000 Interrupts und LED-Toogle pro Sekunde)
//#define timer_config TCCR1A=(1<<WGM10)|(1<<WGM11);TCCR1B=(1<<WGM13)|(1<<CS00);OCR1AL=30:OCR1AH=0
//
//// mit Kopplung IR LED (Toogle PB0)
//#define timer_start_Pulse TCCR1A|=(1<<COM1A0)
//
//// ohne Kopplung IR LED (Toogle PB0)
//#define timer_start_Pause TCCR1A&=~(1<<COM1A0)
//
//// Timer anhalten
//#define timer_stop TCCR1A=0;TCCR1B=0;OCR1AL=0;OCR1AH=0
//
//// ==================================================================
//// NEC Code: Dauer der Puls- und Pausephasen [Anzahl der Interrupts pro Bit/Phase]
//// ==================================================================
//
//#define dauer_count 18					// Dauer zw. 2 Interrupts = Frequenz LED
//// 80 kHz => 1/80.000 = 12 us
//
//#define startbit_pulse (9000/dauer_count)				// Startbit Pulse = 360
//#define startbit_pause (4500/dauer_count)				// Startbit Pause = 180
//#define datenbit_pulse (560/dauer_count)				// Datenbit Pulse = 22
//#define datenbit0_pause (560/dauer_count)				// 0-Bit Pause = 22
//#define datenbit1_pause (1690/dauer_count)				// 1-Bit Pause = 67
//#define stopbit_pulse (560/dauer_count)					// Stopbit Pulse = 22
//#define stopbit_pause (4500/dauer_count)				// Stopbit Pause = 360 (mindestens)
//
//// Zaehler fuer Anzahl Interrupts (= Anzahl LED-Impulse)
//volatile uint32_t interrupt_count;
//volatile uint8_t time_done;
//
//// ==================================================================
//// Funktionsprototypen
//// ==================================================================
//void sendBit(uint32_t countPulse,uint32_t countPause);
//void sendStartBit();
//void sendStopBit();
//void sendDatenBit(unsigned char bit_0_1);
//void sendDatenByte(unsigned datenByte);
//
//// ==================================================================
//// Hauptprogramm
//// ==================================================================
//
//void main(void)
//{
	//// 4 Bytes der Sequenz
	//unsigned char byte1;
	//unsigned char byte2;
	//unsigned char byte3;
	//unsigned char byte4;
	//
	//// Beispiel-Sequenz senden
	//byte1 = 31;
	//byte2 = 10;
	//byte3 = 19;
	//byte4 = 72;
	//
	//// kurz warten
	//_delay_ms(1000);
	//
	//// PB0 als Ausgang (Toogle IR LED)
	//DDRB = (1<<IR_OUT_PIN);
	//IR_OUT_PORT|=(1<<IR_OUT_PIN);
	//
	//// Interrupt definieren
	//TIMSK0 = (1<<OCIE0A);
	//
	//// Konfiguration Timer
	//// Phasenkorrekter PWM / Vorteiler 1 / Compare-Wert = 50
	//timer_config;
	//
	//sendStartBit();
	//
	//sendDatenByte(byte1);
	//sendDatenByte(byte2);
	//sendDatenByte(byte3);
	//sendDatenByte(byte4);
	//
	//sendStopBit();
	//
	//timer_stop;
	//TIMSK0 = 0;
	//IR_OUT_PORT = (1<<IR_OUT_PIN);
	//
	//while(1);
//}
//
//// ==================================================================
//// Interrupt Service Routine
//// ==================================================================
//
//ISR(TIM0_COMPA_vect)
//{
	//interrupt_count++;
//}
//
//// ==================================================================
//// Funktionen zum Senden einzelner Bits
//// ==================================================================
//
//void sendBit(uint32_t countPulse,uint32_t countPause)
//{
	//// Pulse Phase
	//cli();
	//timer_start_Pulse;				// LED an PWM gekoppelt
	//interrupt_count = 0;
	//sei();
	//while (interrupt_count<=countPulse);
	//
	//// Pause Phase
	//cli();
	//timer_start_Pause;				// LED nicht an PWM gekoppelt
	//IR_OUT_PORT|=(1<<IR_OUT_PIN);	// LED aus
	//interrupt_count = 0;
	//sei();
	//while (interrupt_count<=countPause);
//}
//
//void sendStartBit()
//{
	//sendBit(startbit_pulse,startbit_pause);
//}
//
//void sendStopBit()
//{
	//sendBit(stopbit_pulse,stopbit_pause);
//}
//
//void sendDatenBit(unsigned char bit_0_1)
//{
	//if (bit_0_1 == 0) {
	//sendBit(datenbit_pulse,datenbit0_pause);}
	//else {
	//sendBit(datenbit_pulse,datenbit1_pause);}
//}
//
//void sendDatenByte(unsigned datenByte)
//{
	//// Bit-Zaehler
	//unsigned char bit_count;
	//unsigned char current_bit;
	//
	//// Schleife ueber 8 Bits des Datenbyte
	//for (bit_count=8;bit_count>=1;bit_count--)
	//{
		//current_bit = (datenByte & (1 << (bit_count-1))) >> (bit_count-1);
		//sendDatenBit(current_bit);
	//}
//}
//