// =====================================================================================
// Includes
// =====================================================================================

#include "global.h"

#include "LED_display.h"
#include "Key_Panel.h"
#include "LED_row.h"
#include "ISR.h"

// =====================================================================================
// Hauptprogramm
// =====================================================================================

int main(void)
{
	// Deklarationen
	uint8_t key=0;
	uint16_t zahl=0;
	uint8_t modus=1;

	// Initialisierung der Devices
	LED_row_init();			// LED Zeile initialisieren
	LEDs_init();			// LEDs initialisieren
	LED_display_init();		// LED Display initialisieren
	Key_Panel_init();		// Tastenfeld initialisieren
	sei();					// Interrupts aktivieren

	// LED-Zeile - Modus anzeigen
	LED_row_segment_on(modus);

	while(1)
	{
		key = Key_Panel_getKey();

		// Ziffer 0-9 gedrckt --> an Zahl anhngen
		if (key<10)
		{
			if ((zahl<25) || (zahl==25 && key<6))
			{
				zahl = zahl * 10 + key;
				LED_display_output(zahl);
			}
		}

		// Taste # oder * gedrckt --> Zahl lschen
		if (key==11 || key==12)
		{
			LED_display_off();
			zahl=0;
		}

		// Taste oben oder unten gedrckt --> LED an-/ausschalten
		if (key==13)
		{
			LED2_on();
			_delay_ms(200);
			LED2_off();
			if (modus>1)
			{
				modus--;
				LED_row_segment_on(modus);
			}
		}
		if (key==14)
		{
			LED1_on();
			_delay_ms(200);
			LED1_off();
			if (modus<16)
			{
				modus++;
				LED_row_segment_on(modus);
			}
		}
	}
}